using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace SimpleDependentCombo
{
	/// <summary>
	/// Summary description for MainDlg.
	/// </summary>
	public class MainDlg : System.Windows.Forms.Form
	{
		private DataTable oGridTable;
		private DataTable oComboTable;
		private DataTable oFinishTable;
		private DataView oFinishView;
		private DataTable oColorTable;
		private DataView oColorView;
		private bool bGridCreated;

		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid grdList;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainDlg()
		{
			InitializeComponent();

			this.oGridTable = new DataTable();
			this.oComboTable = new DataTable();
			this.oFinishTable = new DataTable();
			this.oFinishView = null;
			this.oColorTable = new DataTable();
			this.oColorView = null;
			this.bGridCreated = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdList = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.grdList)).BeginInit();
			this.SuspendLayout();
			// 
			// grdList
			// 
			this.grdList.AllowDragSelectedCols = true;
			this.grdList.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.grdList.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.grdList.Location = new System.Drawing.Point(24, 48);
			this.grdList.Name = "grdList";
			this.grdList.OptimizeInsertRemoveCells = true;
			this.grdList.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.grdList.Size = new System.Drawing.Size(376, 240);
			this.grdList.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.None;
			this.grdList.TabIndex = 0;
			this.grdList.UseListChangedEvent = true;
			//this.grdList.CurrentCellShowingDropDown +=new GridCurrentCellShowingDropDownEventHandler(grdList_CurrentCellShowingDropDown);
			//this.grdList.CurrentCellChanged +=new EventHandler(grdList_CurrentCellChanged);
			// 
			// MainDlg
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 338);
			this.Controls.Add(this.grdList);
			this.Name = "MainDlg";
			this.Text = "MainDlg";
			this.Load += new System.EventHandler(this.OnFormLoad);
			((System.ComponentModel.ISupportInitialize)(this.grdList)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainDlg());
		}

		private void OnFormLoad(object sender, System.EventArgs e)
		{
			this.grdList.BeginUpdate();

			// Create the Grids DataTable
			DataColumn oColumn1 = new DataColumn("Finish", System.Type.GetType("System.Int32"));
			this.oGridTable.Columns.Add(oColumn1);
			GridBoundColumn oGridCol1 = new GridBoundColumn();
			oGridCol1.MappingName = oColumn1.ColumnName;
			this.grdList.GridBoundColumns.Add(oGridCol1);

			DataColumn oColumn2 = new DataColumn("Color", System.Type.GetType("System.Int32"));
			this.oGridTable.Columns.Add(oColumn2);
			GridBoundColumn oGridCol2 = new GridBoundColumn();
			oGridCol2.MappingName = oColumn2.ColumnName;
			this.grdList.GridBoundColumns.Add(oGridCol2);

			// Create the Grid Columns
			this.grdList.GridBoundColumns[0].HeaderText = "Finish";
			this.grdList.GridBoundColumns[0].StyleInfo.CellType = "ComboBox";
			this.grdList.GridBoundColumns[0].StyleInfo.ExclusiveChoiceList = true;
			this.grdList.Model.ColWidths[1] = 200;

			this.grdList.GridBoundColumns[1].HeaderText = "Color";
			this.grdList.GridBoundColumns[1].StyleInfo.CellType = "ComboBox";
			this.grdList.GridBoundColumns[1].StyleInfo.ExclusiveChoiceList = true;
			this.grdList.Model.ColWidths[2] = 200;

			this.grdList.DataSource = this.oGridTable;

			// Create the DataTable for the ComboBox Lists
			DataColumn oDataCol1 = new DataColumn("FinishId", System.Type.GetType("System.Int32"));
			this.oComboTable.Columns.Add(oDataCol1);

			DataColumn oDataCol2 = new DataColumn("FinishName", System.Type.GetType("System.String"));
			this.oComboTable.Columns.Add(oDataCol2);

			DataColumn oDataCol3 = new DataColumn("ColorId", System.Type.GetType("System.Int32"));
			this.oComboTable.Columns.Add(oDataCol3);

			DataColumn oDataCol4 = new DataColumn("ColorName", System.Type.GetType("System.String"));
			this.oComboTable.Columns.Add(oDataCol4);

			DataRow oRow1 = this.oComboTable.NewRow();
			oRow1["FinishId"] = 1;
			oRow1["FinishName"] = "Shiny";
			oRow1["ColorId"] = 1;
			oRow1["ColorName"] = "White";
			this.oComboTable.Rows.Add(oRow1);

			DataRow oRow2 = this.oComboTable.NewRow();
			oRow2["FinishId"] = 1;
			oRow2["FinishName"] = "Shiny";
			oRow2["ColorId"] = 2;
			oRow2["ColorName"] = "Blue";
			this.oComboTable.Rows.Add(oRow2);

			DataRow oRow3 = this.oComboTable.NewRow();
			oRow3["FinishId"] = 1;
			oRow3["FinishName"] = "Shiny";
			oRow3["ColorId"] = 3;
			oRow3["ColorName"] = "Red";
			this.oComboTable.Rows.Add(oRow3);


			// Load Default ComboBox Lists
			// The "Finish" ComboBox List is Static
			this.oFinishTable = this.SelectDistinct("DistinctFinish", this.oComboTable, "FinishId", "FinishName");
			this.oFinishView = new DataView(this.oFinishTable, "", "FinishId", DataViewRowState.CurrentRows);
			this.grdList.GridBoundColumns[0].StyleInfo.DataSource =this. oFinishView;
			this.grdList.GridBoundColumns[0].StyleInfo.DisplayMember = "FinishName";
			this.grdList.GridBoundColumns[0].StyleInfo.ValueMember = "FinishId";

			// The Color List is Dependent on the Finish, So Initially Load All Possibilities
			this.oColorTable = this.SelectDistinct("DistinctColor", this.oComboTable, "ColorId", "ColorName");
			this.oColorView = new DataView(this.oColorTable, "", "ColorId", DataViewRowState.CurrentRows);
			this.grdList.GridBoundColumns[1].StyleInfo.DataSource = this.oColorView;
			this.grdList.GridBoundColumns[1].StyleInfo.DisplayMember = "ColorName";
			this.grdList.GridBoundColumns[1].StyleInfo.ValueMember = "ColorId";

			this.bGridCreated = true;
			this.grdList.EndUpdate();

			this.grdList.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(Model_QueryCellInfo);
			this.grdList.CurrentCellActivating += new GridCurrentCellActivatingEventHandler(grdList_CurrentCellActivating);
			this.grdList.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(Model_SaveCellInfo);
			this.grdList.CurrentCellDeactivated += new GridCurrentCellDeactivatedEventHandler(grdList_CurrentCellDeactivated);
		}

		private bool ColumnEqual(object A, object B) 
		{

			if ( A == DBNull.Value && B == DBNull.Value ) 
				return true; 
			if ( A == DBNull.Value || B == DBNull.Value ) 
				return false; 
			return ( A.Equals(B) ); 

		}

		private DataTable SelectDistinct(string TableName, DataTable SourceTable, string sFieldName1, string sFieldName2) 
		{ 

			DataTable dt = new DataTable(TableName);
			dt.Columns.Add(sFieldName1, SourceTable.Columns[sFieldName1].DataType);
			dt.Columns.Add(sFieldName2, SourceTable.Columns[sFieldName2].DataType);

			object LastValue = null;
			foreach (DataRow dr in SourceTable.Select("", sFieldName1))
			{
				if (LastValue == null || !(ColumnEqual(LastValue, dr[sFieldName1])))
				{
					LastValue = dr[sFieldName1];

					DataRow oNewRow = dt.NewRow();
					oNewRow[sFieldName1] = dr[sFieldName1];
					oNewRow[sFieldName2] = dr[sFieldName2];
					dt.Rows.Add(oNewRow);
				}
			}

			return dt;
		}

//		Obsolete - CurrentCellActivating will populate the list and QueryCellInfo will initialize the style correctly.
//		private void grdList_CurrentCellShowingDropDown(object sender, GridCurrentCellShowingDropDownEventArgs e)
//		{
//			if (!this.bGridCreated) return;
//			
//			GridDataBoundGrid oGrid = sender as GridDataBoundGrid;
//			if (null == oGrid) return;
//			
//			switch (oGrid.CurrentCell.ColIndex)
//			{
//				case 2:
//					string sFilter = "FinishId=" + oGrid[oGrid.CurrentCell.RowIndex, 1].CellValue.ToString();
//			
//					// Select the Rows Available for the Finish
//					DataTable oTempTable = this.oComboTable.Clone();
//					DataRow[] oColorRows = this.oComboTable.Select(sFilter, "ColorName", DataViewRowState.CurrentRows);
//					for (int k=0; k<oColorRows.Length; k++)
//						oTempTable.ImportRow(oColorRows[k]);
//			
//					// Create a Table With Only the Distinct Marks
//					this.oColorTable = this.SelectDistinct("DistinctColor", oTempTable, "ColorId", "ColorName");
//					this.oColorView = new DataView(this.oColorTable, "", "ColorName", DataViewRowState.CurrentRows);
//			
//					GridComboBoxCellRenderer oCellRend = oGrid.CurrentCell.Renderer as GridComboBoxCellRenderer;
//					if (null != oCellRend)
//					{
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DataSource = this.oColorView;
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DisplayMember = "ColorName";
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).ValueMember = "ColorId";
//					}
//					break;
//			}
//		}

//		Obsolete - CurrentCellActivating will populate the list and QueryCellInfo will initialize the style correctly.
//		private void grdList_CurrentCellChanged(object sender, EventArgs e)
//		{
//			GridDataBoundGrid oGrid = sender as GridDataBoundGrid;
//			if (null == oGrid) return;
//
//			for (int i=0; i<oGrid.Selections.Ranges.Count; i++)
//			{
//				GridRangeInfo oRange = oGrid.Selections.Ranges[i] as GridRangeInfo;
//				for (int j=oRange.Top; j<=oRange.Bottom; j++)
//				{
//					oGrid[j, oGrid.CurrentCell.ColIndex].Text = oGrid.CurrentCell.Renderer.ControlValue.ToString();
//				}
//			}
//		}

		// Cache the datasource for current cell so that Model_QueryCellInfo does not slow down the app.
		int futureCCRowIndex = -1;
		int futureCCColIndex = -1;

		object ccDataSource;
		string ccDisplayMember;
		string ccValueMember;

		// Return data source from cached values only for the combobox cell in column 2 and for the current row
		private void Model_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if (e.ColIndex == 2)
			{
				if (e.RowIndex == futureCCRowIndex && e.ColIndex == futureCCColIndex)
				{
					Console.WriteLine("Model_QueryCellInfo: " + e.ToString());
					e.Style.DataSource = this.ccDataSource;
					e.Style.DisplayMember = this.ccDisplayMember;
					e.Style.ValueMember = this.ccValueMember;
				}
			}
		}

		// Calculate the datasource to be displayed for combobox when it becomes the current cell.
		// Model_QueryCellInfo will return these cached values the next time it is called.
		private void grdList_CurrentCellActivating(object sender, GridCurrentCellActivatingEventArgs e)
		{
			Console.WriteLine("grdList_CurrentCellActivating: " + e.ToString());
			if (!this.bGridCreated) return;

			GridDataBoundGrid oGrid = sender as GridDataBoundGrid;
			if (null == oGrid) return;

			futureCCRowIndex = e.RowIndex;
			futureCCColIndex = e.ColIndex;

			switch (futureCCColIndex)
			{
				case 2:
				{
					object value = oGrid[futureCCRowIndex, 1].CellValue;
					if (value != null && !(value is DBNull) && value.ToString() != "")
					{
						string sFilter = "FinishId=" + oGrid[futureCCRowIndex, 1].CellValue.ToString();

						// Select the Rows Available for the Finish
						DataTable oTempTable = this.oComboTable.Clone();
						DataRow[] oColorRows = this.oComboTable.Select(sFilter, "ColorName", DataViewRowState.CurrentRows);
						for (int k=0; k<oColorRows.Length; k++)
							oTempTable.ImportRow(oColorRows[k]);

						// Create a Table With Only the Distinct Marks
						this.oColorTable = this.SelectDistinct("DistinctColor", oTempTable, "ColorId", "ColorName");
						this.oColorView = new DataView(this.oColorTable, "", "ColorName", DataViewRowState.CurrentRows);

						ccDataSource =  this.oColorView;
						ccDisplayMember = "ColorName";
						ccValueMember = "ColorId";

						//					Just in case you want to manually assign values/initialized GridListControl ...
						//					GridComboBoxCellRenderer oCellRend = oGrid.GetCellRenderer(futureCCRowIndex, futureCCColIndex) as GridComboBoxCellRenderer;
						//					if (null != oCellRend)
						//					{
						//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DataSource = this.oColorView;
						//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DisplayMember = "ColorName";
						//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).ValueMember = "ColorId";
						//					}
					}
					break;
				}

//				case 1:
//				{
//					GridComboBoxCellRenderer oCellRend = oGrid.GetCellRenderer(futureCCRowIndex, futureCCColIndex) as GridComboBoxCellRenderer;
//					if (null != oCellRend)
//					{
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DataSource = this.oFinishView;
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).DisplayMember = "FinishName";
//						((GridComboBoxListBoxPart)oCellRend.ListBoxPart).ValueMember = "FinishId";
//					}
//					break;
//				}

			}
		}

		private void Model_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			Console.WriteLine("Model_SaveCellInfo: " + e.ToString());

		}

		private void grdList_CurrentCellDeactivated(object sender, GridCurrentCellDeactivatedEventArgs e)
		{
			Console.WriteLine("grdList_CurrentCellDeactivated: " + e.ToString());
			// Reset cache
			futureCCRowIndex = -1;
			futureCCColIndex = -1;
			ccDataSource = null;
		}
	}
}
